/* ClipboardManager.c generated by valac 0.46.6, the Vala compiler
 * generated from ClipboardManager.vala, do not modify */

/*
* Copyright (c) 2017 David Hewitt (https://github.com/davidmhewitt)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: David Hewitt <davidmhewitt@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkx.h>
#include <X11/extensions/XTest.h>

#define CLIPPED_TYPE_CLIPBOARD_MANAGER (clipped_clipboard_manager_get_type ())
#define CLIPPED_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManager))
#define CLIPPED_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManagerClass))
#define CLIPPED_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLIPPED_TYPE_CLIPBOARD_MANAGER))
#define CLIPPED_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLIPPED_TYPE_CLIPBOARD_MANAGER))
#define CLIPPED_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManagerClass))

typedef struct _ClippedClipboardManager ClippedClipboardManager;
typedef struct _ClippedClipboardManagerClass ClippedClipboardManagerClass;
typedef struct _ClippedClipboardManagerPrivate ClippedClipboardManagerPrivate;
enum  {
	CLIPPED_CLIPBOARD_MANAGER_0_PROPERTY,
	CLIPPED_CLIPBOARD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* clipped_clipboard_manager_properties[CLIPPED_CLIPBOARD_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	CLIPPED_CLIPBOARD_MANAGER_ON_TEXT_COPIED_SIGNAL,
	CLIPPED_CLIPBOARD_MANAGER_NUM_SIGNALS
};
static guint clipped_clipboard_manager_signals[CLIPPED_CLIPBOARD_MANAGER_NUM_SIGNALS] = {0};

struct _ClippedClipboardManager {
	GObject parent_instance;
	ClippedClipboardManagerPrivate * priv;
};

struct _ClippedClipboardManagerClass {
	GObjectClass parent_class;
	void (*start) (ClippedClipboardManager* self);
};

struct _ClippedClipboardManagerPrivate {
	GtkClipboard* clipboard;
};

static gint ClippedClipboardManager_private_offset;
static gpointer clipped_clipboard_manager_parent_class = NULL;

GType clipped_clipboard_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClippedClipboardManager, g_object_unref)
static void clipped_clipboard_manager_on_clipboard_event (ClippedClipboardManager* self);
static void _clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                               GdkEventOwnerChange* event,
                                                                               gpointer self);
ClippedClipboardManager* clipped_clipboard_manager_new (void);
ClippedClipboardManager* clipped_clipboard_manager_construct (GType object_type);
void clipped_clipboard_manager_start (ClippedClipboardManager* self);
static void clipped_clipboard_manager_real_start (ClippedClipboardManager* self);
static gchar* clipped_clipboard_manager_request_text (ClippedClipboardManager* self);
void clipped_clipboard_manager_paste (ClippedClipboardManager* self);
static void clipped_clipboard_manager_perform_key_event (const gchar* accelerator,
                                                  gboolean press,
                                                  gulong delay);
static void clipped_clipboard_manager_finalize (GObject * obj);

static inline gpointer
clipped_clipboard_manager_get_instance_private (ClippedClipboardManager* self)
{
	return G_STRUCT_MEMBER_P (self, ClippedClipboardManager_private_offset);
}

static void
_clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                          GdkEventOwnerChange* event,
                                                                          gpointer self)
{
#line 33 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	clipped_clipboard_manager_on_clipboard_event ((ClippedClipboardManager*) self);
#line 109 "ClipboardManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 117 "ClipboardManager.c"
}

ClippedClipboardManager*
clipped_clipboard_manager_construct (GType object_type)
{
	ClippedClipboardManager * self = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	self = (ClippedClipboardManager*) g_object_new (object_type, NULL);
#line 29 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp0_ = gtk_clipboard_get (GDK_SELECTION_CLIPBOARD);
#line 29 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 29 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_g_object_unref0 (self->priv->clipboard);
#line 29 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	self->priv->clipboard = _tmp1_;
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	return self;
#line 138 "ClipboardManager.c"
}

ClippedClipboardManager*
clipped_clipboard_manager_new (void)
{
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	return clipped_clipboard_manager_construct (CLIPPED_TYPE_CLIPBOARD_MANAGER);
#line 146 "ClipboardManager.c"
}

static void
clipped_clipboard_manager_real_start (ClippedClipboardManager* self)
{
	GtkClipboard* _tmp0_;
#line 37 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp0_ = self->priv->clipboard;
#line 37 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_signal_connect_object (_tmp0_, "owner-change", (GCallback) _clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change, self, 0);
#line 157 "ClipboardManager.c"
}

void
clipped_clipboard_manager_start (ClippedClipboardManager* self)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	CLIPPED_CLIPBOARD_MANAGER_GET_CLASS (self)->start (self);
#line 167 "ClipboardManager.c"
}

static void
clipped_clipboard_manager_on_clipboard_event (ClippedClipboardManager* self)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean text_available = FALSE;
#line 40 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp0_ = clipped_clipboard_manager_request_text (self);
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	text = _tmp0_;
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp3_ = text;
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	if (_tmp3_ != NULL) {
#line 189 "ClipboardManager.c"
		const gchar* _tmp4_;
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp4_ = text;
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 195 "ClipboardManager.c"
	} else {
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp2_ = FALSE;
#line 199 "ClipboardManager.c"
	}
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	if (_tmp2_) {
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp1_ = TRUE;
#line 205 "ClipboardManager.c"
	} else {
		GtkClipboard* _tmp5_;
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp5_ = self->priv->clipboard;
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp1_ = gtk_clipboard_wait_is_text_available (_tmp5_);
#line 212 "ClipboardManager.c"
	}
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	text_available = _tmp1_;
#line 44 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	if (text_available) {
#line 218 "ClipboardManager.c"
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
#line 45 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp7_ = text;
#line 45 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		if (_tmp7_ != NULL) {
#line 225 "ClipboardManager.c"
			const gchar* _tmp8_;
#line 45 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp8_ = text;
#line 45 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp6_ = g_strcmp0 (_tmp8_, "") != 0;
#line 231 "ClipboardManager.c"
		} else {
#line 45 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp6_ = FALSE;
#line 235 "ClipboardManager.c"
		}
#line 45 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		if (_tmp6_) {
#line 239 "ClipboardManager.c"
			const gchar* _tmp9_;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp9_ = text;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			g_signal_emit (self, clipped_clipboard_manager_signals[CLIPPED_CLIPBOARD_MANAGER_ON_TEXT_COPIED_SIGNAL], 0, _tmp9_);
#line 245 "ClipboardManager.c"
		}
	}
#line 40 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_g_free0 (text);
#line 250 "ClipboardManager.c"
}

static gchar*
clipped_clipboard_manager_request_text (ClippedClipboardManager* self)
{
	gchar* _result_ = NULL;
	GtkClipboard* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 51 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp0_ = self->priv->clipboard;
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp1_ = gtk_clipboard_wait_for_text (_tmp0_);
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_result_ = _tmp1_;
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	result = _result_;
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	return result;
#line 272 "ClipboardManager.c"
}

void
clipped_clipboard_manager_paste (ClippedClipboardManager* self)
{
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_return_if_fail (self != NULL);
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	clipped_clipboard_manager_perform_key_event ("<Control>v", TRUE, (gulong) 100);
#line 58 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	clipped_clipboard_manager_perform_key_event ("<Control>v", FALSE, (gulong) 0);
#line 284 "ClipboardManager.c"
}

static void
clipped_clipboard_manager_perform_key_event (const gchar* accelerator,
                                             gboolean press,
                                             gulong delay)
{
	guint keysym = 0U;
	GdkModifierType modifiers = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
	Display* display = NULL;
	Display* _tmp2_;
	gint keycode = 0;
	Display* _tmp3_;
#line 61 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_return_if_fail (accelerator != NULL);
#line 65 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	gtk_accelerator_parse (accelerator, &_tmp0_, &_tmp1_);
#line 65 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	keysym = _tmp0_;
#line 65 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	modifiers = _tmp1_;
#line 66 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp2_ = gdk_x11_get_default_xdisplay ();
#line 66 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	display = _tmp2_;
#line 67 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp3_ = display;
#line 67 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	keycode = (gint) XKeysymToKeycode (_tmp3_, (gulong) keysym);
#line 69 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	if (keycode != 0) {
#line 318 "ClipboardManager.c"
		GdkModifierType _tmp4_;
		GdkModifierType _tmp7_;
		Display* _tmp10_;
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp4_ = modifiers;
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		if ((_tmp4_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 326 "ClipboardManager.c"
			gint modcode = 0;
			Display* _tmp5_;
			Display* _tmp6_;
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp5_ = display;
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			modcode = (gint) XKeysymToKeycode (_tmp5_, (gulong) GDK_KEY_Control_L);
#line 72 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp6_ = display;
#line 72 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			XTestFakeKeyEvent (_tmp6_, (guint) modcode, press, delay);
#line 338 "ClipboardManager.c"
		}
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp7_ = modifiers;
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		if ((_tmp7_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 344 "ClipboardManager.c"
			gint modcode = 0;
			Display* _tmp8_;
			Display* _tmp9_;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp8_ = display;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			modcode = (gint) XKeysymToKeycode (_tmp8_, (gulong) GDK_KEY_Shift_L);
#line 77 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			_tmp9_ = display;
#line 77 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
			XTestFakeKeyEvent (_tmp9_, (guint) modcode, press, delay);
#line 356 "ClipboardManager.c"
		}
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		_tmp10_ = display;
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
		XTestFakeKeyEvent (_tmp10_, (guint) keycode, press, delay);
#line 362 "ClipboardManager.c"
	}
}

static void
clipped_clipboard_manager_class_init (ClippedClipboardManagerClass * klass,
                                      gpointer klass_data)
{
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	clipped_clipboard_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_type_class_adjust_private_offset (klass, &ClippedClipboardManager_private_offset);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	((ClippedClipboardManagerClass *) klass)->start = (void (*) (ClippedClipboardManager*)) clipped_clipboard_manager_real_start;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	G_OBJECT_CLASS (klass)->finalize = clipped_clipboard_manager_finalize;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	clipped_clipboard_manager_signals[CLIPPED_CLIPBOARD_MANAGER_ON_TEXT_COPIED_SIGNAL] = g_signal_new ("on-text-copied", CLIPPED_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 380 "ClipboardManager.c"
}

static void
clipped_clipboard_manager_instance_init (ClippedClipboardManager * self,
                                         gpointer klass)
{
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	self->priv = clipped_clipboard_manager_get_instance_private (self);
#line 24 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	self->priv->clipboard = NULL;
#line 391 "ClipboardManager.c"
}

static void
clipped_clipboard_manager_finalize (GObject * obj)
{
	ClippedClipboardManager * self;
	GtkClipboard* _tmp0_;
	guint _tmp1_;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManager);
#line 33 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_tmp0_ = self->priv->clipboard;
#line 33 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_signal_parse_name ("owner-change", gtk_clipboard_get_type (), &_tmp1_, NULL, FALSE);
#line 33 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change, self);
#line 24 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	_g_object_unref0 (self->priv->clipboard);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardManager.vala"
	G_OBJECT_CLASS (clipped_clipboard_manager_parent_class)->finalize (obj);
#line 412 "ClipboardManager.c"
}

GType
clipped_clipboard_manager_get_type (void)
{
	static volatile gsize clipped_clipboard_manager_type_id__volatile = 0;
	if (g_once_init_enter (&clipped_clipboard_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClippedClipboardManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clipped_clipboard_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClippedClipboardManager), 0, (GInstanceInitFunc) clipped_clipboard_manager_instance_init, NULL };
		GType clipped_clipboard_manager_type_id;
		clipped_clipboard_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ClippedClipboardManager", &g_define_type_info, 0);
		ClippedClipboardManager_private_offset = g_type_add_instance_private (clipped_clipboard_manager_type_id, sizeof (ClippedClipboardManagerPrivate));
		g_once_init_leave (&clipped_clipboard_manager_type_id__volatile, clipped_clipboard_manager_type_id);
	}
	return clipped_clipboard_manager_type_id__volatile;
}

