/* ClipboardStore.c generated by valac 0.46.6, the Vala compiler
 * generated from ClipboardStore.vala, do not modify */

/*
* Copyright (c) 2017 David Hewitt (https://github.com/davidmhewitt)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: David Hewitt <davidmhewitt@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define CLIPPED_TYPE_CLIPBOARD_STORE (clipped_clipboard_store_get_type ())
#define CLIPPED_CLIPBOARD_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStore))
#define CLIPPED_CLIPBOARD_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStoreClass))
#define CLIPPED_IS_CLIPBOARD_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLIPPED_TYPE_CLIPBOARD_STORE))
#define CLIPPED_IS_CLIPBOARD_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLIPPED_TYPE_CLIPBOARD_STORE))
#define CLIPPED_CLIPBOARD_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStoreClass))

typedef struct _ClippedClipboardStore ClippedClipboardStore;
typedef struct _ClippedClipboardStoreClass ClippedClipboardStoreClass;
typedef struct _ClippedClipboardStorePrivate ClippedClipboardStorePrivate;
enum  {
	CLIPPED_CLIPBOARD_STORE_0_PROPERTY,
	CLIPPED_CLIPBOARD_STORE_NUM_PROPERTIES
};
static GParamSpec* clipped_clipboard_store_properties[CLIPPED_CLIPBOARD_STORE_NUM_PROPERTIES];
typedef enum  {
	CLIPPED_CLIPBOARD_STORE_CLIPBOARD_ENTRY_TYPE_TEXT
} ClippedClipboardStoreClipboardEntryType;

#define CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY_TYPE (clipped_clipboard_store_clipboard_entry_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

#define CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY (clipped_clipboard_store_clipboard_entry_get_type ())
typedef struct _ClippedClipboardStoreClipboardEntry ClippedClipboardStoreClipboardEntry;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ClippedClipboardStore {
	GObject parent_instance;
	ClippedClipboardStorePrivate * priv;
};

struct _ClippedClipboardStoreClass {
	GObjectClass parent_class;
};

struct _ClippedClipboardStorePrivate {
	gchar* db_location;
	sqlite3* db;
	guint retention_period_days;
};

struct _ClippedClipboardStoreClipboardEntry {
	gint id;
	ClippedClipboardStoreClipboardEntryType type;
	GDateTime* date_copied;
	gchar* text;
	gchar* application_id;
	gchar* application_name;
	gchar* optional_uri;
	gint optional_int;
};

static gint ClippedClipboardStore_private_offset;
static gpointer clipped_clipboard_store_parent_class = NULL;

GType clipped_clipboard_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClippedClipboardStore, g_object_unref)
GType clipped_clipboard_store_clipboard_entry_type_get_type (void) G_GNUC_CONST;
ClippedClipboardStore* clipped_clipboard_store_new (guint retention_period);
ClippedClipboardStore* clipped_clipboard_store_construct (GType object_type,
                                                          guint retention_period);
static gboolean clipped_clipboard_store_open_database (ClippedClipboardStore* self);
static void clipped_clipboard_store_prepare_database (ClippedClipboardStore* self);
void clipped_clipboard_store_set_retention_days (ClippedClipboardStore* self,
                                                 guint days);
void clipped_clipboard_store_insert_text_item (ClippedClipboardStore* self,
                                               const gchar* text);
static void clipped_clipboard_store_purge_older_entries (ClippedClipboardStore* self);
GType clipped_clipboard_store_clipboard_entry_get_type (void) G_GNUC_CONST;
ClippedClipboardStoreClipboardEntry* clipped_clipboard_store_clipboard_entry_dup (const ClippedClipboardStoreClipboardEntry* self);
void clipped_clipboard_store_clipboard_entry_free (ClippedClipboardStoreClipboardEntry* self);
void clipped_clipboard_store_clipboard_entry_copy (const ClippedClipboardStoreClipboardEntry* self,
                                                   ClippedClipboardStoreClipboardEntry* dest);
void clipped_clipboard_store_clipboard_entry_destroy (ClippedClipboardStoreClipboardEntry* self);
GeeArrayList* clipped_clipboard_store_get_most_recent_items (ClippedClipboardStore* self,
                                                             gint limit);
GeeArrayList* clipped_clipboard_store_search (ClippedClipboardStore* self,
                                              const gchar* search_term,
                                              const gchar* app_search_term,
                                              gint limit);
void clipped_clipboard_store_select_item (ClippedClipboardStore* self,
                                          gint id);
static void clipped_clipboard_store_touch_access_date (ClippedClipboardStore* self,
                                                gint id);
static void clipped_clipboard_store_finalize (GObject * obj);

static inline gpointer
clipped_clipboard_store_get_instance_private (ClippedClipboardStore* self)
{
	return G_STRUCT_MEMBER_P (self, ClippedClipboardStore_private_offset);
}

GType
clipped_clipboard_store_clipboard_entry_type_get_type (void)
{
	static volatile gsize clipped_clipboard_store_clipboard_entry_type_type_id__volatile = 0;
	if (g_once_init_enter (&clipped_clipboard_store_clipboard_entry_type_type_id__volatile)) {
		static const GEnumValue values[] = {{CLIPPED_CLIPBOARD_STORE_CLIPBOARD_ENTRY_TYPE_TEXT, "CLIPPED_CLIPBOARD_STORE_CLIPBOARD_ENTRY_TYPE_TEXT", "text"}, {0, NULL, NULL}};
		GType clipped_clipboard_store_clipboard_entry_type_type_id;
		clipped_clipboard_store_clipboard_entry_type_type_id = g_enum_register_static ("ClippedClipboardStoreClipboardEntryType", values);
		g_once_init_leave (&clipped_clipboard_store_clipboard_entry_type_type_id__volatile, clipped_clipboard_store_clipboard_entry_type_type_id);
	}
	return clipped_clipboard_store_clipboard_entry_type_type_id__volatile;
}

ClippedClipboardStore*
clipped_clipboard_store_construct (GType object_type,
                                   guint retention_period)
{
	ClippedClipboardStore * self = NULL;
	gchar* config_dir_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* config_dir = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self = (ClippedClipboardStore*) g_object_new (object_type, NULL);
#line 44 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self->priv->retention_period_days = retention_period;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "clipped", NULL);
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	config_dir_path = _tmp1_;
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = config_dir_path;
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	config_dir = _tmp3_;
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = config_dir;
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (!g_file_query_exists (_tmp4_, NULL)) {
#line 188 "ClipboardStore.c"
		{
			GFile* _tmp5_;
#line 50 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_tmp5_ = config_dir;
#line 50 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error0_);
#line 50 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "ClipboardStore.c"
				goto __catch5_g_error;
			}
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			e = _inner_error0_;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_inner_error0_ = NULL;
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_tmp6_ = e;
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_tmp7_ = _tmp6_->message;
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			g_warning ("ClipboardStore.vala:52: Failed to create directory to store clipboard " \
"data: %s", _tmp7_);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_g_error_free0 (e);
#line 219 "ClipboardStore.c"
		}
		__finally5:
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_g_object_unref0 (config_dir);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			_g_free0 (config_dir_path);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			g_clear_error (&_inner_error0_);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			return NULL;
#line 234 "ClipboardStore.c"
		}
	}
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = config_dir_path;
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = g_build_path (G_DIR_SEPARATOR_S, _tmp8_, "ClipboardStore.sqlite", NULL);
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (self->priv->db_location);
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self->priv->db_location = _tmp9_;
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp10_ = self->priv->db_location;
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp11_ = g_file_new_for_path (_tmp10_);
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp12_ = _tmp11_;
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp13_ = g_file_query_exists (_tmp12_, NULL);
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_object_unref0 (_tmp12_);
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (_tmp13_) {
#line 58 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipped_clipboard_store_open_database (self);
#line 259 "ClipboardStore.c"
	} else {
#line 60 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipped_clipboard_store_open_database (self);
#line 61 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipped_clipboard_store_prepare_database (self);
#line 265 "ClipboardStore.c"
	}
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_object_unref0 (config_dir);
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (config_dir_path);
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return self;
#line 273 "ClipboardStore.c"
}

ClippedClipboardStore*
clipped_clipboard_store_new (guint retention_period)
{
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return clipped_clipboard_store_construct (CLIPPED_TYPE_CLIPBOARD_STORE, retention_period);
#line 281 "ClipboardStore.c"
}

void
clipped_clipboard_store_set_retention_days (ClippedClipboardStore* self,
                                            guint days)
{
#line 65 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (self != NULL);
#line 66 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self->priv->retention_period_days = days;
#line 292 "ClipboardStore.c"
}

static gboolean
clipped_clipboard_store_open_database (ClippedClipboardStore* self)
{
	gint ec = 0;
	const gchar* _tmp0_;
	sqlite3* _tmp1_ = NULL;
	gint _tmp2_;
	gboolean result = FALSE;
#line 69 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = self->priv->db_location;
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = sqlite3_open (_tmp0_, &_tmp1_);
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_close0 (self->priv->db);
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self->priv->db = _tmp1_;
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp2_;
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 317 "ClipboardStore.c"
		const gchar* _tmp3_;
#line 72 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp3_ = self->priv->db_location;
#line 72 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_critical ("ClipboardStore.vala:72: Unable to create/open database at %s", _tmp3_);
#line 73 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		result = FALSE;
#line 73 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return result;
#line 327 "ClipboardStore.c"
	} else {
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		result = TRUE;
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return result;
#line 333 "ClipboardStore.c"
	}
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar* * errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result = 0;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 363 "ClipboardStore.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 374 "ClipboardStore.c"
	} else {
#line 40 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 40 "sqlite3.vapi"
		_vala_errmsg = NULL;
#line 380 "ClipboardStore.c"
	}
#line 42 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 42 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 43 "sqlite3.vapi"
	result = ec;
#line 43 "sqlite3.vapi"
	if (errmsg) {
#line 43 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 392 "ClipboardStore.c"
	} else {
#line 43 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 396 "ClipboardStore.c"
	}
#line 43 "sqlite3.vapi"
	return result;
#line 400 "ClipboardStore.c"
}

static void
clipped_clipboard_store_prepare_database (ClippedClipboardStore* self)
{
	gchar* query = NULL;
	gchar* _tmp0_;
	gchar* error_message = NULL;
	gint ec = 0;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
#line 79 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (self != NULL);
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = g_strdup ("\n" \
"            CREATE TABLE entry (\n" \
"                type                INT         NOT NULL,\n" \
"                date_copied         DATETIME    NOT NULL    DEFAULT (S" \
"TRFTIME('%Y-%m-%d %H:%M:%f', 'NOW', 'localtime')),\n" \
"                last_used           DATETIME    NOT NULL    DEFAULT (S" \
"TRFTIME('%Y-%m-%d %H:%M:%f', 'NOW', 'localtime')),\n" \
"\t            text\t            TEXT,\n" \
"                application_id      TEXT,\n" \
"                application_name    TEXT,\n" \
"\t            optional_uri        TEXT,\n" \
"                optional_int        INTEGER,\n" \
"                checksum            STRING      NOT NULL,\n" \
"                UNIQUE (checksum)\n" \
"            );\n" \
"            ");
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	query = _tmp0_;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = self->priv->db;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = query;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (error_message);
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	error_message = _tmp3_;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp4_;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 434 "ClipboardStore.c"
		const gchar* _tmp5_;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp5_ = error_message;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_critical ("ClipboardStore.vala:97: Unable to create tables in database. Error: %s", _tmp5_);
#line 440 "ClipboardStore.c"
	}
#line 79 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (error_message);
#line 79 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (query);
#line 446 "ClipboardStore.c"
}

void
clipped_clipboard_store_insert_text_item (ClippedClipboardStore* self,
                                          const gchar* text)
{
	gchar* checksum = NULL;
	gchar* _tmp0_;
	sqlite3_stmt* stmt = NULL;
#line 107 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	static const char prepared_query_str[] = "INSERT OR IGNORE INTO entry (type, text, checksum) VALUES (0, $TEXT, $" \
"CHECKSUM);";
#line 458 "ClipboardStore.c"
	gint ec = 0;
	sqlite3* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint param_position = 0;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gchar* _tmp10_;
	GDestroyNotify _tmp11_;
	sqlite3_stmt* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GDestroyNotify _tmp16_;
	sqlite3_stmt* _tmp17_;
#line 101 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (self != NULL);
#line 101 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (text != NULL);
#line 102 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	clipped_clipboard_store_purge_older_entries (self);
#line 104 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = g_compute_checksum_for_string (G_CHECKSUM_SHA1, text, (gsize) -1);
#line 104 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	checksum = _tmp0_;
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = self->priv->db;
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = strlen (prepared_query_str);
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp3_ = _tmp2_;
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp1_, prepared_query_str, _tmp3_, &_tmp4_, NULL);
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	stmt = _tmp4_;
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp5_;
#line 109 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 502 "ClipboardStore.c"
		sqlite3* _tmp6_;
		const gchar* _tmp7_;
#line 110 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp6_ = self->priv->db;
#line 110 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp7_ = sqlite3_errmsg (_tmp6_);
#line 110 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:110: Error inserting clipboard entry: %s\n", _tmp7_);
#line 111 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_sqlite3_finalize0 (stmt);
#line 111 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (checksum);
#line 111 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return;
#line 517 "ClipboardStore.c"
	}
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = stmt;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp8_, "$TEXT");
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = stmt;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp10_ = g_strdup (text);
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp11_ = g_free;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_text (_tmp9_, param_position, _tmp10_, -1, _tmp11_);
#line 118 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp12_ = stmt;
#line 118 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp12_, "$CHECKSUM");
#line 119 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 120 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp13_ = stmt;
#line 120 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp14_ = checksum;
#line 120 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 120 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp16_ = g_free;
#line 120 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_text (_tmp13_, param_position, _tmp15_, -1, _tmp16_);
#line 122 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp17_ = stmt;
#line 122 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = sqlite3_step (_tmp17_);
#line 123 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_DONE) {
#line 555 "ClipboardStore.c"
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
#line 124 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp18_ = self->priv->db;
#line 124 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 124 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:124: Error inserting clipboard entry: %s\n", _tmp19_);
#line 564 "ClipboardStore.c"
	}
#line 101 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 101 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (checksum);
#line 570 "ClipboardStore.c"
}

GeeArrayList*
clipped_clipboard_store_get_most_recent_items (ClippedClipboardStore* self,
                                               gint limit)
{
	sqlite3_stmt* stmt = NULL;
#line 130 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	static const char prepared_query_str[] = "SELECT rowid, * FROM entry ORDER BY date_copied DESC LIMIT $LIMIT;";
#line 580 "ClipboardStore.c"
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp9_;
	GeeArrayList* result = NULL;
#line 128 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = self->priv->db;
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = strlen (prepared_query_str);
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = _tmp1_;
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	stmt = _tmp3_;
#line 131 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp4_;
#line 132 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 611 "ClipboardStore.c"
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
#line 133 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp5_ = self->priv->db;
#line 133 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp6_ = sqlite3_errmsg (_tmp5_);
#line 133 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:133: Error fetching clipboard entries: %s\n", _tmp6_);
#line 134 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		result = NULL;
#line 134 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_sqlite3_finalize0 (stmt);
#line 134 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return result;
#line 626 "ClipboardStore.c"
	}
#line 137 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp7_ = stmt;
#line 137 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$LIMIT");
#line 138 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 140 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = stmt;
#line 140 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_int (_tmp8_, param_position, limit);
#line 142 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = gee_array_list_new (CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY, (GBoxedCopyFunc) clipped_clipboard_store_clipboard_entry_dup, (GDestroyNotify) clipped_clipboard_store_clipboard_entry_free, NULL, NULL, NULL);
#line 142 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	entries = _tmp9_;
#line 143 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	while (TRUE) {
#line 644 "ClipboardStore.c"
		sqlite3_stmt* _tmp10_;
		ClippedClipboardStoreClipboardEntry entry = {0};
		sqlite3_stmt* _tmp11_;
		sqlite3_stmt* _tmp12_;
		sqlite3_stmt* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		ClippedClipboardStoreClipboardEntry _tmp16_ = {0};
		GeeArrayList* _tmp17_;
		ClippedClipboardStoreClipboardEntry _tmp18_;
#line 143 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp10_ = stmt;
#line 143 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		ec = sqlite3_step (_tmp10_);
#line 143 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		if (!(ec == SQLITE_ROW)) {
#line 143 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			break;
#line 663 "ClipboardStore.c"
		}
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp11_ = stmt;
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp12_ = stmt;
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp13_ = stmt;
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp14_ = (const gchar*) sqlite3_column_text (_tmp13_, 4);
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		memset (&_tmp16_, 0, sizeof (ClippedClipboardStoreClipboardEntry));
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp16_.id = sqlite3_column_int (_tmp11_, 0);
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp16_.type = (ClippedClipboardStoreClipboardEntryType) sqlite3_column_int (_tmp12_, 1);
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (_tmp16_.text);
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp16_.text = _tmp15_;
#line 144 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		entry = _tmp16_;
#line 149 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp17_ = entries;
#line 149 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp18_ = entry;
#line 149 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, &_tmp18_);
#line 143 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipped_clipboard_store_clipboard_entry_destroy (&entry);
#line 695 "ClipboardStore.c"
	}
#line 151 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_DONE) {
#line 699 "ClipboardStore.c"
		sqlite3* _tmp19_;
		const gchar* _tmp20_;
#line 152 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp19_ = self->priv->db;
#line 152 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp20_ = sqlite3_errmsg (_tmp19_);
#line 152 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:152: Error fetching clipboard entries: %s\n", _tmp20_);
#line 153 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		result = NULL;
#line 153 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_object_unref0 (entries);
#line 153 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_sqlite3_finalize0 (stmt);
#line 153 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return result;
#line 716 "ClipboardStore.c"
	}
#line 156 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	result = entries;
#line 156 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 156 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return result;
#line 724 "ClipboardStore.c"
}

GeeArrayList*
clipped_clipboard_store_search (ClippedClipboardStore* self,
                                const gchar* search_term,
                                const gchar* app_search_term,
                                gint limit)
{
	sqlite3_stmt* stmt = NULL;
	gchar* wildcard_search_term = NULL;
	gchar* _tmp0_;
	gchar* wildcard_app_search_term = NULL;
	gchar* prepared_query_str = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint ec = 0;
	sqlite3* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_ = NULL;
	gint _tmp12_;
	gint param_position = 0;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	GDestroyNotify _tmp19_;
	const gchar* _tmp20_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp27_;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp28_;
	GeeArrayList* result = NULL;
#line 159 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 159 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_val_if_fail (search_term != NULL, NULL);
#line 162 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = g_strdup_printf ("%%%s%%", search_term);
#line 162 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	wildcard_search_term = _tmp0_;
#line 163 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	wildcard_app_search_term = NULL;
#line 164 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (app_search_term != NULL) {
#line 772 "ClipboardStore.c"
		gchar* _tmp1_;
#line 165 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp1_ = g_strdup_printf ("%%%s%%", app_search_term);
#line 165 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (wildcard_app_search_term);
#line 165 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		wildcard_app_search_term = _tmp1_;
#line 780 "ClipboardStore.c"
	}
#line 168 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = g_strdup ("");
#line 168 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	prepared_query_str = _tmp2_;
#line 169 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp3_ = wildcard_app_search_term;
#line 169 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (_tmp3_ != NULL) {
#line 790 "ClipboardStore.c"
		gchar* _tmp4_;
#line 170 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp4_ = g_strdup ("\n" \
"                SELECT rowid, * FROM entry \n" \
"                WHERE text LIKE $TEXT_SEARCH\n" \
"                AND application_name LIKE $APP_SEARCH\n" \
"                ORDER BY date_copied DESC\n" \
"                LIMIT $LIMIT;\n" \
"            ");
#line 170 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (prepared_query_str);
#line 170 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		prepared_query_str = _tmp4_;
#line 798 "ClipboardStore.c"
	} else {
		gchar* _tmp5_;
#line 178 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp5_ = g_strdup ("\n" \
"                SELECT rowid, * FROM entry\n" \
"                WHERE text LIKE $TEXT_SEARCH\n" \
"                ORDER BY date_copied DESC\n" \
"                LIMIT $LIMIT;\n" \
"            ");
#line 178 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (prepared_query_str);
#line 178 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		prepared_query_str = _tmp5_;
#line 807 "ClipboardStore.c"
	}
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp6_ = self->priv->db;
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp7_ = prepared_query_str;
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = prepared_query_str;
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = strlen (_tmp8_);
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp10_ = _tmp9_;
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp12_ = sqlite3_prepare_v2 (_tmp6_, _tmp7_, _tmp10_, &_tmp11_, NULL);
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	stmt = _tmp11_;
#line 185 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp12_;
#line 186 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 829 "ClipboardStore.c"
		sqlite3* _tmp13_;
		const gchar* _tmp14_;
#line 187 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp13_ = self->priv->db;
#line 187 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp14_ = sqlite3_errmsg (_tmp13_);
#line 187 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:187: Error searching clipboard entries: %s\n", _tmp14_);
#line 188 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		result = NULL;
#line 188 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (prepared_query_str);
#line 188 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (wildcard_app_search_term);
#line 188 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (wildcard_search_term);
#line 188 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_sqlite3_finalize0 (stmt);
#line 188 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return result;
#line 850 "ClipboardStore.c"
	}
#line 191 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp15_ = stmt;
#line 191 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp15_, "$TEXT_SEARCH");
#line 192 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 193 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp16_ = stmt;
#line 193 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp17_ = wildcard_search_term;
#line 193 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 193 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp19_ = g_free;
#line 193 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_text (_tmp16_, param_position, _tmp18_, -1, _tmp19_);
#line 195 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp20_ = wildcard_app_search_term;
#line 195 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (_tmp20_ != NULL) {
#line 872 "ClipboardStore.c"
		sqlite3_stmt* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		GDestroyNotify _tmp25_;
#line 196 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp21_ = stmt;
#line 196 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		param_position = sqlite3_bind_parameter_index (_tmp21_, "$APP_SEARCH");
#line 197 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_vala_assert (param_position > 0, "param_position > 0");
#line 198 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp22_ = stmt;
#line 198 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp23_ = wildcard_app_search_term;
#line 198 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 198 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp25_ = g_free;
#line 198 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		sqlite3_bind_text (_tmp22_, param_position, _tmp24_, -1, _tmp25_);
#line 894 "ClipboardStore.c"
	}
#line 201 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp26_ = stmt;
#line 201 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp26_, "$LIMIT");
#line 202 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 203 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp27_ = stmt;
#line 203 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_int (_tmp27_, param_position, limit);
#line 205 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp28_ = gee_array_list_new (CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY, (GBoxedCopyFunc) clipped_clipboard_store_clipboard_entry_dup, (GDestroyNotify) clipped_clipboard_store_clipboard_entry_free, NULL, NULL, NULL);
#line 205 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	entries = _tmp28_;
#line 206 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	while (TRUE) {
#line 912 "ClipboardStore.c"
		sqlite3_stmt* _tmp29_;
		ClippedClipboardStoreClipboardEntry entry = {0};
		sqlite3_stmt* _tmp30_;
		sqlite3_stmt* _tmp31_;
		sqlite3_stmt* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		ClippedClipboardStoreClipboardEntry _tmp35_ = {0};
		GeeArrayList* _tmp36_;
		ClippedClipboardStoreClipboardEntry _tmp37_;
#line 206 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp29_ = stmt;
#line 206 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		ec = sqlite3_step (_tmp29_);
#line 206 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		if (!(ec == SQLITE_ROW)) {
#line 206 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
			break;
#line 931 "ClipboardStore.c"
		}
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp30_ = stmt;
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp31_ = stmt;
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp32_ = stmt;
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp33_ = (const gchar*) sqlite3_column_text (_tmp32_, 4);
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp34_ = g_strdup (_tmp33_);
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		memset (&_tmp35_, 0, sizeof (ClippedClipboardStoreClipboardEntry));
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp35_.id = sqlite3_column_int (_tmp30_, 0);
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp35_.type = (ClippedClipboardStoreClipboardEntryType) sqlite3_column_int (_tmp31_, 1);
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (_tmp35_.text);
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp35_.text = _tmp34_;
#line 207 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		entry = _tmp35_;
#line 212 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp36_ = entries;
#line 212 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp37_ = entry;
#line 212 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, &_tmp37_);
#line 206 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipped_clipboard_store_clipboard_entry_destroy (&entry);
#line 963 "ClipboardStore.c"
	}
#line 214 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_DONE) {
#line 967 "ClipboardStore.c"
		sqlite3* _tmp38_;
		const gchar* _tmp39_;
#line 215 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp38_ = self->priv->db;
#line 215 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp39_ = sqlite3_errmsg (_tmp38_);
#line 215 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:215: Error searching clipboard entries: %s\n", _tmp39_);
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		result = NULL;
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_object_unref0 (entries);
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (prepared_query_str);
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (wildcard_app_search_term);
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (wildcard_search_term);
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_sqlite3_finalize0 (stmt);
#line 216 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		return result;
#line 990 "ClipboardStore.c"
	}
#line 219 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	result = entries;
#line 219 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (prepared_query_str);
#line 219 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (wildcard_app_search_term);
#line 219 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (wildcard_search_term);
#line 219 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 219 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return result;
#line 1004 "ClipboardStore.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 238 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return self ? g_object_ref (self) : NULL;
#line 1012 "ClipboardStore.c"
}

void
clipped_clipboard_store_select_item (ClippedClipboardStore* self,
                                     gint id)
{
	sqlite3_stmt* stmt = NULL;
#line 224 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	static const char prepared_query_str[] = "SELECT rowid, * FROM entry WHERE rowid = $ROWID;";
#line 1022 "ClipboardStore.c"
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
#line 222 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (self != NULL);
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = self->priv->db;
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = strlen (prepared_query_str);
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = _tmp1_;
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	stmt = _tmp3_;
#line 225 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp4_;
#line 226 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 1051 "ClipboardStore.c"
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
#line 227 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp5_ = self->priv->db;
#line 227 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp6_ = sqlite3_errmsg (_tmp5_);
#line 227 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:227: Error getting clipboard entry for pasting: %s" \
"\n", _tmp6_);
#line 1060 "ClipboardStore.c"
	}
#line 230 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp7_ = stmt;
#line 230 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$ROWID");
#line 231 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 233 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = stmt;
#line 233 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_int (_tmp8_, param_position, id);
#line 235 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = stmt;
#line 235 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = sqlite3_step (_tmp9_);
#line 235 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec == SQLITE_ROW) {
#line 1078 "ClipboardStore.c"
		gchar* text = NULL;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		GtkClipboard* clipboard = NULL;
		GdkDisplay* _tmp13_;
		GtkClipboard* _tmp14_;
		GtkClipboard* _tmp15_;
		GtkClipboard* _tmp16_;
		const gchar* _tmp17_;
#line 236 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipped_clipboard_store_touch_access_date (self, id);
#line 237 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp10_ = stmt;
#line 237 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 4);
#line 237 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 237 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		text = _tmp12_;
#line 238 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp13_ = gdk_display_get_default ();
#line 238 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp14_ = gtk_clipboard_get_default (_tmp13_);
#line 238 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 238 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		clipboard = _tmp15_;
#line 239 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp16_ = clipboard;
#line 239 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp17_ = text;
#line 239 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		gtk_clipboard_set_text (_tmp16_, _tmp17_, -1);
#line 235 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_object_unref0 (clipboard);
#line 235 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_g_free0 (text);
#line 1117 "ClipboardStore.c"
	}
#line 222 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 1121 "ClipboardStore.c"
}

static void
clipped_clipboard_store_touch_access_date (ClippedClipboardStore* self,
                                           gint id)
{
	sqlite3_stmt* stmt = NULL;
#line 245 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	static const char prepared_query_str[] = "UPDATE entry\n" \
"               SET last_used = STRFTIME('%Y-%m-%d %H:%M:%f', 'NOW', 'l" \
"ocaltime')\n" \
"               WHERE rowid = $ROWID;";
#line 1131 "ClipboardStore.c"
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
#line 243 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (self != NULL);
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = self->priv->db;
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = strlen (prepared_query_str);
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = _tmp1_;
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	stmt = _tmp3_;
#line 249 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp4_;
#line 250 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 1160 "ClipboardStore.c"
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
#line 251 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp5_ = self->priv->db;
#line 251 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp6_ = sqlite3_errmsg (_tmp5_);
#line 251 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:251: Error updating last_paste date on clipboard e" \
"ntry: %s\n", _tmp6_);
#line 1169 "ClipboardStore.c"
	}
#line 254 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp7_ = stmt;
#line 254 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$ROWID");
#line 255 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 257 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = stmt;
#line 257 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_int (_tmp8_, param_position, id);
#line 259 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = stmt;
#line 259 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_step (_tmp9_);
#line 243 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 1187 "ClipboardStore.c"
}

static void
clipped_clipboard_store_purge_older_entries (ClippedClipboardStore* self)
{
	sqlite3_stmt* stmt = NULL;
#line 264 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	static const char prepared_query_str[] = "DELETE FROM entry WHERE last_used <= STRFTIME('%Y-%m-%d %H:%M:%f', 'NO" \
"W', 'localtime', $DIFFERENCE);";
#line 1196 "ClipboardStore.c"
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	gchar* difference = NULL;
	gchar* _tmp8_;
	sqlite3_stmt* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GDestroyNotify _tmp12_;
	sqlite3_stmt* _tmp13_;
#line 262 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_return_if_fail (self != NULL);
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = self->priv->db;
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = strlen (prepared_query_str);
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = _tmp1_;
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	stmt = _tmp3_;
#line 266 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = _tmp4_;
#line 267 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_OK) {
#line 1230 "ClipboardStore.c"
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
#line 268 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp5_ = self->priv->db;
#line 268 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp6_ = sqlite3_errmsg (_tmp5_);
#line 268 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:268: Error purging older clipboard entries: %s\n", _tmp6_);
#line 1239 "ClipboardStore.c"
	}
#line 271 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp7_ = stmt;
#line 271 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$DIFFERENCE");
#line 272 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_vala_assert (param_position > 0, "param_position > 0");
#line 274 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = g_strdup_printf ("-%u days", self->priv->retention_period_days);
#line 274 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	difference = _tmp8_;
#line 276 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = stmt;
#line 276 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp10_ = difference;
#line 276 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 276 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp12_ = g_free;
#line 276 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	sqlite3_bind_text (_tmp9_, param_position, _tmp11_, -1, _tmp12_);
#line 278 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp13_ = stmt;
#line 278 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	ec = sqlite3_step (_tmp13_);
#line 278 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	if (ec != SQLITE_DONE) {
#line 1267 "ClipboardStore.c"
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
#line 279 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp14_ = self->priv->db;
#line 279 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		_tmp15_ = sqlite3_errmsg (_tmp14_);
#line 279 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
		g_warning ("ClipboardStore.vala:279: Error purging older clipboard entries: %s\n", _tmp15_);
#line 1276 "ClipboardStore.c"
	}
#line 262 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (difference);
#line 262 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_finalize0 (stmt);
#line 1282 "ClipboardStore.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1290 "ClipboardStore.c"
}

void
clipped_clipboard_store_clipboard_entry_copy (const ClippedClipboardStoreClipboardEntry* self,
                                              ClippedClipboardStoreClipboardEntry* dest)
{
	ClippedClipboardStoreClipboardEntryType _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).id = (*self).id;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp0_ = (*self).type;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).type = _tmp0_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp1_ = (*self).date_copied;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp2_ = _g_date_time_ref0 (_tmp1_);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_date_time_unref0 ((*dest).date_copied);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).date_copied = _tmp2_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp3_ = (*self).text;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*dest).text);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).text = _tmp4_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp5_ = (*self).application_id;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*dest).application_id);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).application_id = _tmp6_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp7_ = (*self).application_name;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*dest).application_name);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).application_name = _tmp8_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp9_ = (*self).optional_uri;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*dest).optional_uri);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).optional_uri = _tmp10_;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	(*dest).optional_int = (*self).optional_int;
#line 1356 "ClipboardStore.c"
}

void
clipped_clipboard_store_clipboard_entry_destroy (ClippedClipboardStoreClipboardEntry* self)
{
#line 35 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_date_time_unref0 ((*self).date_copied);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*self).text);
#line 37 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*self).application_id);
#line 38 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*self).application_name);
#line 39 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 ((*self).optional_uri);
#line 1372 "ClipboardStore.c"
}

ClippedClipboardStoreClipboardEntry*
clipped_clipboard_store_clipboard_entry_dup (const ClippedClipboardStoreClipboardEntry* self)
{
	ClippedClipboardStoreClipboardEntry* dup;
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	dup = g_new0 (ClippedClipboardStoreClipboardEntry, 1);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	clipped_clipboard_store_clipboard_entry_copy (self, dup);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	return dup;
#line 1385 "ClipboardStore.c"
}

void
clipped_clipboard_store_clipboard_entry_free (ClippedClipboardStoreClipboardEntry* self)
{
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	clipped_clipboard_store_clipboard_entry_destroy (self);
#line 32 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_free (self);
#line 1395 "ClipboardStore.c"
}

GType
clipped_clipboard_store_clipboard_entry_get_type (void)
{
	static volatile gsize clipped_clipboard_store_clipboard_entry_type_id__volatile = 0;
	if (g_once_init_enter (&clipped_clipboard_store_clipboard_entry_type_id__volatile)) {
		GType clipped_clipboard_store_clipboard_entry_type_id;
		clipped_clipboard_store_clipboard_entry_type_id = g_boxed_type_register_static ("ClippedClipboardStoreClipboardEntry", (GBoxedCopyFunc) clipped_clipboard_store_clipboard_entry_dup, (GBoxedFreeFunc) clipped_clipboard_store_clipboard_entry_free);
		g_once_init_leave (&clipped_clipboard_store_clipboard_entry_type_id__volatile, clipped_clipboard_store_clipboard_entry_type_id);
	}
	return clipped_clipboard_store_clipboard_entry_type_id__volatile;
}

static void
clipped_clipboard_store_class_init (ClippedClipboardStoreClass * klass,
                                    gpointer klass_data)
{
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	clipped_clipboard_store_parent_class = g_type_class_peek_parent (klass);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	g_type_class_adjust_private_offset (klass, &ClippedClipboardStore_private_offset);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	G_OBJECT_CLASS (klass)->finalize = clipped_clipboard_store_finalize;
#line 1420 "ClipboardStore.c"
}

static void
clipped_clipboard_store_instance_init (ClippedClipboardStore * self,
                                       gpointer klass)
{
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self->priv = clipped_clipboard_store_get_instance_private (self);
#line 26 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self->priv->retention_period_days = (guint) 7;
#line 1431 "ClipboardStore.c"
}

static void
clipped_clipboard_store_finalize (GObject * obj)
{
	ClippedClipboardStore * self;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStore);
#line 23 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_g_free0 (self->priv->db_location);
#line 24 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	_sqlite3_close0 (self->priv->db);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/ClipboardStore.vala"
	G_OBJECT_CLASS (clipped_clipboard_store_parent_class)->finalize (obj);
#line 1446 "ClipboardStore.c"
}

GType
clipped_clipboard_store_get_type (void)
{
	static volatile gsize clipped_clipboard_store_type_id__volatile = 0;
	if (g_once_init_enter (&clipped_clipboard_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClippedClipboardStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clipped_clipboard_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClippedClipboardStore), 0, (GInstanceInitFunc) clipped_clipboard_store_instance_init, NULL };
		GType clipped_clipboard_store_type_id;
		clipped_clipboard_store_type_id = g_type_register_static (G_TYPE_OBJECT, "ClippedClipboardStore", &g_define_type_info, 0);
		ClippedClipboardStore_private_offset = g_type_add_instance_private (clipped_clipboard_store_type_id, sizeof (ClippedClipboardStorePrivate));
		g_once_init_leave (&clipped_clipboard_store_type_id__volatile, clipped_clipboard_store_type_id);
	}
	return clipped_clipboard_store_type_id__volatile;
}

