/* KeybindingManager.c generated by valac 0.46.6, the Vala compiler
 * generated from KeybindingManager.vala, do not modify */

/*
* Copyright (c) 2017 David Hewitt (https://github.com/davidmhewitt)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: David Hewitt <davidmhewitt@gmail.com>
*/

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkx.h>
#include <gobject/gvaluecollector.h>

#define TYPE_KEYBINDING_MANAGER (keybinding_manager_get_type ())
#define KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManager))
#define KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))
#define IS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYBINDING_MANAGER))
#define IS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYBINDING_MANAGER))
#define KEYBINDING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYBINDING_MANAGER, KeybindingManagerClass))

typedef struct _KeybindingManager KeybindingManager;
typedef struct _KeybindingManagerClass KeybindingManagerClass;
typedef struct _KeybindingManagerPrivate KeybindingManagerPrivate;

#define KEYBINDING_MANAGER_TYPE_KEYBINDING (keybinding_manager_keybinding_get_type ())
#define KEYBINDING_MANAGER_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBINDING_MANAGER_TYPE_KEYBINDING, KeybindingManagerKeybinding))
#define KEYBINDING_MANAGER_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBINDING_MANAGER_TYPE_KEYBINDING, KeybindingManagerKeybindingClass))
#define KEYBINDING_MANAGER_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBINDING_MANAGER_TYPE_KEYBINDING))
#define KEYBINDING_MANAGER_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBINDING_MANAGER_TYPE_KEYBINDING))
#define KEYBINDING_MANAGER_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBINDING_MANAGER_TYPE_KEYBINDING, KeybindingManagerKeybindingClass))

typedef struct _KeybindingManagerKeybinding KeybindingManagerKeybinding;
typedef struct _KeybindingManagerKeybindingClass KeybindingManagerKeybindingClass;
enum  {
	KEYBINDING_MANAGER_0_PROPERTY,
	KEYBINDING_MANAGER_NUM_PROPERTIES
};
static GParamSpec* keybinding_manager_properties[KEYBINDING_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef void (*KeybindingManagerKeybindingHandlerFunc) (GdkEvent* event, gpointer user_data);
#define _keybinding_manager_keybinding_unref0(var) ((var == NULL) ? NULL : (var = (keybinding_manager_keybinding_unref (var), NULL)))
typedef struct _KeybindingManagerKeybindingPrivate KeybindingManagerKeybindingPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _KeybindingManagerParamSpecKeybinding KeybindingManagerParamSpecKeybinding;

struct _KeybindingManager {
	GObject parent_instance;
	KeybindingManagerPrivate * priv;
};

struct _KeybindingManagerClass {
	GObjectClass parent_class;
};

struct _KeybindingManagerPrivate {
	GeeList* bindings;
};

struct _KeybindingManagerKeybinding {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KeybindingManagerKeybindingPrivate * priv;
};

struct _KeybindingManagerKeybindingClass {
	GTypeClass parent_class;
	void (*finalize) (KeybindingManagerKeybinding *self);
};

struct _KeybindingManagerKeybindingPrivate {
	gchar* _accelerator;
	gint _keycode;
	GdkModifierType _modifiers;
	KeybindingManagerKeybindingHandlerFunc _handler;
	gpointer _handler_target;
	GDestroyNotify _handler_target_destroy_notify;
};

struct _KeybindingManagerParamSpecKeybinding {
	GParamSpec parent_instance;
};

static gint KeybindingManager_private_offset;
static gpointer keybinding_manager_parent_class = NULL;
static guint* keybinding_manager_lock_modifiers;
static gint keybinding_manager_lock_modifiers_length1;
static guint* keybinding_manager_lock_modifiers = NULL;
static gint keybinding_manager_lock_modifiers_length1 = 0;
static gint _keybinding_manager_lock_modifiers_size_ = 0;
static gint KeybindingManagerKeybinding_private_offset;
static gpointer keybinding_manager_keybinding_parent_class = NULL;

GType keybinding_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeybindingManager, g_object_unref)
static gpointer keybinding_manager_keybinding_ref (gpointer instance);
static void keybinding_manager_keybinding_unref (gpointer instance);
static GParamSpec* keybinding_manager_param_spec_keybinding (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags) G_GNUC_UNUSED;
static void keybinding_manager_value_set_keybinding (GValue* value,
                                              gpointer v_object) G_GNUC_UNUSED;
static void keybinding_manager_value_take_keybinding (GValue* value,
                                               gpointer v_object) G_GNUC_UNUSED;
static gpointer keybinding_manager_value_get_keybinding (const GValue* value) G_GNUC_UNUSED;
static GType keybinding_manager_keybinding_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeybindingManagerKeybinding, keybinding_manager_keybinding_unref)
KeybindingManager* keybinding_manager_new (void);
KeybindingManager* keybinding_manager_construct (GType object_type);
GdkFilterReturn keybinding_manager_event_filter (KeybindingManager* self,
                                                 GdkXEvent* gdk_xevent,
                                                 GdkEvent* gdk_event);
static GdkFilterReturn _keybinding_manager_event_filter_gdk_filter_func (GdkXEvent* xevent,
                                                                  GdkEvent* event,
                                                                  gpointer self);
void keybinding_manager_bind (KeybindingManager* self,
                              const gchar* accelerator,
                              KeybindingManagerKeybindingHandlerFunc handler,
                              gpointer handler_target);
static KeybindingManagerKeybinding* keybinding_manager_keybinding_new (const gchar* accelerator,
                                                                gint keycode,
                                                                GdkModifierType modifiers,
                                                                KeybindingManagerKeybindingHandlerFunc handler,
                                                                gpointer handler_target);
static KeybindingManagerKeybinding* keybinding_manager_keybinding_construct (GType object_type,
                                                                      const gchar* accelerator,
                                                                      gint keycode,
                                                                      GdkModifierType modifiers,
                                                                      KeybindingManagerKeybindingHandlerFunc handler,
                                                                      gpointer handler_target);
void keybinding_manager_unbind (KeybindingManager* self,
                                const gchar* accelerator);
static const gchar* keybinding_manager_keybinding_get_accelerator (KeybindingManagerKeybinding* self);
static gint keybinding_manager_keybinding_get_keycode (KeybindingManagerKeybinding* self);
static GdkModifierType keybinding_manager_keybinding_get_modifiers (KeybindingManagerKeybinding* self);
static KeybindingManagerKeybindingHandlerFunc keybinding_manager_keybinding_get_handler (KeybindingManagerKeybinding* self,
                                                                                  gpointer* result_target);
static void keybinding_manager_keybinding_set_accelerator (KeybindingManagerKeybinding* self,
                                                    const gchar* value);
static void keybinding_manager_keybinding_set_keycode (KeybindingManagerKeybinding* self,
                                                gint value);
static void keybinding_manager_keybinding_set_modifiers (KeybindingManagerKeybinding* self,
                                                  GdkModifierType value);
static void keybinding_manager_keybinding_set_handler (KeybindingManagerKeybinding* self,
                                                KeybindingManagerKeybindingHandlerFunc value,
                                                gpointer value_target);
static void keybinding_manager_keybinding_finalize (KeybindingManagerKeybinding * obj);
static void keybinding_manager_finalize (GObject * obj);

static inline gpointer
keybinding_manager_get_instance_private (KeybindingManager* self)
{
	return G_STRUCT_MEMBER_P (self, KeybindingManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "KeybindingManager.c"
}

static GdkFilterReturn
_keybinding_manager_event_filter_gdk_filter_func (GdkXEvent* xevent,
                                                  GdkEvent* event,
                                                  gpointer self)
{
	GdkFilterReturn result;
	result = keybinding_manager_event_filter ((KeybindingManager*) self, xevent, event);
#line 58 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return result;
#line 200 "KeybindingManager.c"
}

KeybindingManager*
keybinding_manager_construct (GType object_type)
{
	KeybindingManager * self = NULL;
	GdkWindow* rootwin = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
#line 54 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self = (KeybindingManager*) g_object_new (object_type, NULL);
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = gdk_get_default_root_window ();
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	rootwin = _tmp1_;
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp2_ = rootwin;
#line 57 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (_tmp2_ != NULL) {
#line 223 "KeybindingManager.c"
		GdkWindow* _tmp3_;
#line 58 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp3_ = rootwin;
#line 58 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		gdk_window_add_filter (_tmp3_, _keybinding_manager_event_filter_gdk_filter_func, self);
#line 229 "KeybindingManager.c"
	}
#line 54 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_object_unref0 (rootwin);
#line 54 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return self;
#line 235 "KeybindingManager.c"
}

KeybindingManager*
keybinding_manager_new (void)
{
#line 54 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return keybinding_manager_construct (TYPE_KEYBINDING_MANAGER);
#line 243 "KeybindingManager.c"
}

void
keybinding_manager_bind (KeybindingManager* self,
                         const gchar* accelerator,
                         KeybindingManagerKeybindingHandlerFunc handler,
                         gpointer handler_target)
{
	guint keysym = 0U;
	GdkModifierType modifiers = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
	GdkWindow* rootwin = NULL;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	Display* display = NULL;
	GdkWindow* _tmp4_;
	GdkDisplay* _tmp5_;
	Display* _tmp6_;
	XID xid = 0;
	GdkWindow* _tmp7_;
	gint keycode = 0;
	Display* _tmp8_;
#line 62 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (self != NULL);
#line 62 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (accelerator != NULL);
#line 66 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	gtk_accelerator_parse (accelerator, &_tmp0_, &_tmp1_);
#line 66 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keysym = _tmp0_;
#line 66 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	modifiers = _tmp1_;
#line 68 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp2_ = gdk_get_default_root_window ();
#line 68 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 68 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	rootwin = _tmp3_;
#line 69 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp4_ = rootwin;
#line 69 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp5_ = gdk_window_get_display (_tmp4_);
#line 69 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp6_ = gdk_x11_display_get_xdisplay (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp5_) : NULL);
#line 69 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	display = _tmp6_;
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp7_ = rootwin;
#line 70 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	xid = (XID) gdk_x11_window_get_xid (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp7_) : NULL);
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp8_ = display;
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keycode = (gint) XKeysymToKeycode (_tmp8_, (gulong) keysym);
#line 73 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (keycode != 0) {
#line 301 "KeybindingManager.c"
		guint* _tmp9_;
		gint _tmp9__length1;
		KeybindingManagerKeybinding* binding = NULL;
		GdkModifierType _tmp12_;
		KeybindingManagerKeybinding* _tmp13_;
		GeeList* _tmp14_;
		KeybindingManagerKeybinding* _tmp15_;
#line 74 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		gdk_error_trap_push ();
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp9_ = keybinding_manager_lock_modifiers;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp9__length1 = keybinding_manager_lock_modifiers_length1;
#line 315 "KeybindingManager.c"
		{
			guint* lock_modifier_collection = NULL;
			gint lock_modifier_collection_length1 = 0;
			gint _lock_modifier_collection_size_ = 0;
			gint lock_modifier_it = 0;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			lock_modifier_collection = _tmp9_;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			lock_modifier_collection_length1 = _tmp9__length1;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			for (lock_modifier_it = 0; lock_modifier_it < lock_modifier_collection_length1; lock_modifier_it = lock_modifier_it + 1) {
#line 327 "KeybindingManager.c"
				guint lock_modifier = 0U;
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				lock_modifier = lock_modifier_collection[lock_modifier_it];
#line 331 "KeybindingManager.c"
				{
					Display* _tmp10_;
					GdkModifierType _tmp11_;
#line 77 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp10_ = display;
#line 77 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp11_ = modifiers;
#line 77 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					XGrabKey (_tmp10_, keycode, (guint) (_tmp11_ | lock_modifier), (Window) xid, FALSE, (gint) GrabModeAsync, (gint) GrabModeAsync);
#line 341 "KeybindingManager.c"
				}
			}
		}
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		gdk_flush ();
#line 82 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp12_ = modifiers;
#line 82 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp13_ = keybinding_manager_keybinding_new (accelerator, keycode, _tmp12_, handler, handler_target);
#line 82 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		binding = _tmp13_;
#line 83 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp14_ = self->priv->bindings;
#line 83 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp15_ = binding;
#line 83 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		gee_collection_add ((GeeCollection*) _tmp14_, _tmp15_);
#line 73 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_keybinding_manager_keybinding_unref0 (binding);
#line 361 "KeybindingManager.c"
	}
#line 62 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_object_unref0 (rootwin);
#line 365 "KeybindingManager.c"
}

void
keybinding_manager_unbind (KeybindingManager* self,
                           const gchar* accelerator)
{
	GdkWindow* rootwin = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	Display* display = NULL;
	GdkWindow* _tmp2_;
	GdkDisplay* _tmp3_;
	Display* _tmp4_;
	XID xid = 0;
	GdkWindow* _tmp5_;
	GeeList* remove_bindings = NULL;
	GeeArrayList* _tmp6_;
	GeeList* _tmp28_;
	GeeList* _tmp29_;
#line 87 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (self != NULL);
#line 87 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (accelerator != NULL);
#line 89 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = gdk_get_default_root_window ();
#line 89 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 89 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	rootwin = _tmp1_;
#line 90 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp2_ = rootwin;
#line 90 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp3_ = gdk_window_get_display (_tmp2_);
#line 90 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp4_ = gdk_x11_display_get_xdisplay (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp3_) : NULL);
#line 90 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	display = _tmp4_;
#line 91 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp5_ = rootwin;
#line 91 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	xid = (XID) gdk_x11_window_get_xid (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp5_) : NULL);
#line 93 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp6_ = gee_array_list_new (KEYBINDING_MANAGER_TYPE_KEYBINDING, (GBoxedCopyFunc) keybinding_manager_keybinding_ref, (GDestroyNotify) keybinding_manager_keybinding_unref, NULL, NULL, NULL);
#line 93 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	remove_bindings = (GeeList*) _tmp6_;
#line 411 "KeybindingManager.c"
	{
		GeeList* _binding_list = NULL;
		GeeList* _tmp7_;
		GeeList* _tmp8_;
		gint _binding_size = 0;
		GeeList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _binding_index = 0;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp7_ = self->priv->bindings;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_binding_list = _tmp8_;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp9_ = _binding_list;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_tmp11_ = _tmp10_;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_binding_size = _tmp11_;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_binding_index = -1;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		while (TRUE) {
#line 439 "KeybindingManager.c"
			KeybindingManagerKeybinding* binding = NULL;
			GeeList* _tmp12_;
			gpointer _tmp13_;
			GEqualFunc _tmp14_;
			KeybindingManagerKeybinding* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_binding_index = _binding_index + 1;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			if (!(_binding_index < _binding_size)) {
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				break;
#line 453 "KeybindingManager.c"
			}
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp12_ = _binding_list;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp13_ = gee_list_get (_tmp12_, _binding_index);
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			binding = (KeybindingManagerKeybinding*) _tmp13_;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp14_ = g_str_equal;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp15_ = binding;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp16_ = keybinding_manager_keybinding_get_accelerator (_tmp15_);
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp17_ = _tmp16_;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			if (_tmp14_ (accelerator, _tmp17_)) {
#line 471 "KeybindingManager.c"
				guint* _tmp18_;
				gint _tmp18__length1;
				GeeList* _tmp26_;
				KeybindingManagerKeybinding* _tmp27_;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp18_ = keybinding_manager_lock_modifiers;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp18__length1 = keybinding_manager_lock_modifiers_length1;
#line 480 "KeybindingManager.c"
				{
					guint* lock_modifier_collection = NULL;
					gint lock_modifier_collection_length1 = 0;
					gint _lock_modifier_collection_size_ = 0;
					gint lock_modifier_it = 0;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					lock_modifier_collection = _tmp18_;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					lock_modifier_collection_length1 = _tmp18__length1;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					for (lock_modifier_it = 0; lock_modifier_it < lock_modifier_collection_length1; lock_modifier_it = lock_modifier_it + 1) {
#line 492 "KeybindingManager.c"
						guint lock_modifier = 0U;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
						lock_modifier = lock_modifier_collection[lock_modifier_it];
#line 496 "KeybindingManager.c"
						{
							Display* _tmp19_;
							KeybindingManagerKeybinding* _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							KeybindingManagerKeybinding* _tmp23_;
							GdkModifierType _tmp24_;
							GdkModifierType _tmp25_;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp19_ = display;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp20_ = binding;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp21_ = keybinding_manager_keybinding_get_keycode (_tmp20_);
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp22_ = _tmp21_;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp23_ = binding;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp24_ = keybinding_manager_keybinding_get_modifiers (_tmp23_);
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							_tmp25_ = _tmp24_;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
							XUngrabKey (_tmp19_, _tmp22_, (guint) _tmp25_, (Window) xid);
#line 521 "KeybindingManager.c"
						}
					}
				}
#line 99 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp26_ = remove_bindings;
#line 99 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp27_ = binding;
#line 99 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				gee_collection_add ((GeeCollection*) _tmp26_, _tmp27_);
#line 531 "KeybindingManager.c"
			}
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_keybinding_manager_keybinding_unref0 (binding);
#line 535 "KeybindingManager.c"
		}
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		_g_object_unref0 (_binding_list);
#line 539 "KeybindingManager.c"
	}
#line 103 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp28_ = self->priv->bindings;
#line 103 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp29_ = remove_bindings;
#line 103 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp28_, (GeeCollection*) _tmp29_);
#line 87 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_object_unref0 (remove_bindings);
#line 87 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_object_unref0 (rootwin);
#line 551 "KeybindingManager.c"
}

GdkFilterReturn
keybinding_manager_event_filter (KeybindingManager* self,
                                 GdkXEvent* gdk_xevent,
                                 GdkEvent* gdk_event)
{
	GdkFilterReturn filter_return = 0;
	void* pointer = NULL;
	XEvent* xevent = NULL;
	void* _tmp0_;
	XEvent* _tmp1_;
	GdkFilterReturn result = 0;
#line 106 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 106 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (gdk_xevent != NULL, 0);
#line 106 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (gdk_event != NULL, 0);
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	filter_return = GDK_FILTER_CONTINUE;
#line 110 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	pointer = &gdk_xevent;
#line 111 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = pointer;
#line 111 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	xevent = (XEvent*) _tmp0_;
#line 113 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp1_ = xevent;
#line 113 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if ((*_tmp1_).type == ((gint) KeyPress)) {
#line 583 "KeybindingManager.c"
		{
			GeeList* _binding_list = NULL;
			GeeList* _tmp2_;
			GeeList* _tmp3_;
			gint _binding_size = 0;
			GeeList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _binding_index = 0;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp2_ = self->priv->bindings;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_binding_list = _tmp3_;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp4_ = _binding_list;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_tmp6_ = _tmp5_;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_binding_size = _tmp6_;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_binding_index = -1;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			while (TRUE) {
#line 611 "KeybindingManager.c"
				KeybindingManagerKeybinding* binding = NULL;
				GeeList* _tmp7_;
				gpointer _tmp8_;
				guint event_mods = 0U;
				XEvent* _tmp9_;
				XKeyEvent _tmp10_;
				guint* _tmp11_;
				gint _tmp11__length1;
				guint _tmp12_;
				gboolean _tmp13_ = FALSE;
				XEvent* _tmp14_;
				XKeyEvent _tmp15_;
				KeybindingManagerKeybinding* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_binding_index = _binding_index + 1;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				if (!(_binding_index < _binding_size)) {
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					break;
#line 633 "KeybindingManager.c"
				}
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp7_ = _binding_list;
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp8_ = gee_list_get (_tmp7_, _binding_index);
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				binding = (KeybindingManagerKeybinding*) _tmp8_;
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp9_ = xevent;
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp10_ = (*_tmp9_).xkey;
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp11_ = keybinding_manager_lock_modifiers;
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp11__length1 = keybinding_manager_lock_modifiers_length1;
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp12_ = _tmp11_[7];
#line 115 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				event_mods = _tmp10_.state & (~_tmp12_);
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp14_ = xevent;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp15_ = (*_tmp14_).xkey;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp16_ = binding;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp17_ = keybinding_manager_keybinding_get_keycode (_tmp16_);
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_tmp18_ = _tmp17_;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				if (_tmp15_.keycode == ((guint) _tmp18_)) {
#line 665 "KeybindingManager.c"
					KeybindingManagerKeybinding* _tmp19_;
					GdkModifierType _tmp20_;
					GdkModifierType _tmp21_;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp19_ = binding;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp20_ = keybinding_manager_keybinding_get_modifiers (_tmp19_);
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp21_ = _tmp20_;
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp13_ = event_mods == ((guint) _tmp21_);
#line 677 "KeybindingManager.c"
				} else {
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp13_ = FALSE;
#line 681 "KeybindingManager.c"
				}
#line 116 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				if (_tmp13_) {
#line 685 "KeybindingManager.c"
					KeybindingManagerKeybinding* _tmp22_;
					KeybindingManagerKeybindingHandlerFunc _tmp23_ = NULL;
					gpointer _tmp23__target = NULL;
					KeybindingManagerKeybindingHandlerFunc _tmp24_;
					gpointer _tmp24__target;
#line 117 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp22_ = binding;
#line 117 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp23_ = keybinding_manager_keybinding_get_handler (_tmp22_, &_tmp23__target);
#line 117 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp24_ = _tmp23_;
#line 117 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp24__target = _tmp23__target;
#line 117 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
					_tmp24_ (gdk_event, _tmp24__target);
#line 701 "KeybindingManager.c"
				}
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
				_keybinding_manager_keybinding_unref0 (binding);
#line 705 "KeybindingManager.c"
			}
#line 114 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			_g_object_unref0 (_binding_list);
#line 709 "KeybindingManager.c"
		}
	}
#line 122 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	result = filter_return;
#line 122 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return result;
#line 716 "KeybindingManager.c"
}

static inline gpointer
keybinding_manager_keybinding_get_instance_private (KeybindingManagerKeybinding* self)
{
	return G_STRUCT_MEMBER_P (self, KeybindingManagerKeybinding_private_offset);
}

static KeybindingManagerKeybinding*
keybinding_manager_keybinding_construct (GType object_type,
                                         const gchar* accelerator,
                                         gint keycode,
                                         GdkModifierType modifiers,
                                         KeybindingManagerKeybindingHandlerFunc handler,
                                         gpointer handler_target)
{
	KeybindingManagerKeybinding* self = NULL;
#line 38 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (accelerator != NULL, NULL);
#line 38 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self = (KeybindingManagerKeybinding*) g_type_create_instance (object_type);
#line 40 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_keybinding_set_accelerator (self, accelerator);
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_keybinding_set_keycode (self, keycode);
#line 42 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_keybinding_set_modifiers (self, modifiers);
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_keybinding_set_handler (self, handler, handler_target);
#line 38 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return self;
#line 748 "KeybindingManager.c"
}

static KeybindingManagerKeybinding*
keybinding_manager_keybinding_new (const gchar* accelerator,
                                   gint keycode,
                                   GdkModifierType modifiers,
                                   KeybindingManagerKeybindingHandlerFunc handler,
                                   gpointer handler_target)
{
#line 38 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return keybinding_manager_keybinding_construct (KEYBINDING_MANAGER_TYPE_KEYBINDING, accelerator, keycode, modifiers, handler, handler_target);
#line 760 "KeybindingManager.c"
}

static const gchar*
keybinding_manager_keybinding_get_accelerator (KeybindingManagerKeybinding* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = self->priv->_accelerator;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	result = _tmp0_;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return result;
#line 776 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_set_accelerator (KeybindingManagerKeybinding* self,
                                               const gchar* value)
{
	gchar* _tmp0_;
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (self != NULL);
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = g_strdup (value);
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_free0 (self->priv->_accelerator);
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_accelerator = _tmp0_;
#line 792 "KeybindingManager.c"
}

static gint
keybinding_manager_keybinding_get_keycode (KeybindingManagerKeybinding* self)
{
	gint result;
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	result = self->priv->_keycode;
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return result;
#line 805 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_set_keycode (KeybindingManagerKeybinding* self,
                                           gint value)
{
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (self != NULL);
#line 47 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_keycode = value;
#line 816 "KeybindingManager.c"
}

static GdkModifierType
keybinding_manager_keybinding_get_modifiers (KeybindingManagerKeybinding* self)
{
	GdkModifierType result;
	GdkModifierType _tmp0_;
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = self->priv->_modifiers;
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	result = _tmp0_;
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return result;
#line 832 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_set_modifiers (KeybindingManagerKeybinding* self,
                                             GdkModifierType value)
{
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (self != NULL);
#line 48 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_modifiers = value;
#line 843 "KeybindingManager.c"
}

static KeybindingManagerKeybindingHandlerFunc
keybinding_manager_keybinding_get_handler (KeybindingManagerKeybinding* self,
                                           gpointer* result_target)
{
	KeybindingManagerKeybindingHandlerFunc result;
	KeybindingManagerKeybindingHandlerFunc _tmp0_;
	gpointer _tmp0__target;
	KeybindingManagerKeybindingHandlerFunc _tmp1_;
	gpointer _tmp1__target;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = self->priv->_handler;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0__target = self->priv->_handler_target;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp1_ = _tmp0_;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp1__target = _tmp0__target;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	*result_target = _tmp1__target;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	result = _tmp1_;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return result;
#line 871 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_set_handler (KeybindingManagerKeybinding* self,
                                           KeybindingManagerKeybindingHandlerFunc value,
                                           gpointer value_target)
{
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	(self->priv->_handler_target_destroy_notify == NULL) ? NULL : (self->priv->_handler_target_destroy_notify (self->priv->_handler_target), NULL);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler = NULL;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler_target = NULL;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler_target_destroy_notify = NULL;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler = value;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler_target = value_target;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler_target_destroy_notify = NULL;
#line 895 "KeybindingManager.c"
}

static void
keybinding_manager_value_keybinding_init (GValue* value)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	value->data[0].v_pointer = NULL;
#line 903 "KeybindingManager.c"
}

static void
keybinding_manager_value_keybinding_free_value (GValue* value)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (value->data[0].v_pointer) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		keybinding_manager_keybinding_unref (value->data[0].v_pointer);
#line 913 "KeybindingManager.c"
	}
}

static void
keybinding_manager_value_keybinding_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (src_value->data[0].v_pointer) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		dest_value->data[0].v_pointer = keybinding_manager_keybinding_ref (src_value->data[0].v_pointer);
#line 925 "KeybindingManager.c"
	} else {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 929 "KeybindingManager.c"
	}
}

static gpointer
keybinding_manager_value_keybinding_peek_pointer (const GValue* value)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return value->data[0].v_pointer;
#line 938 "KeybindingManager.c"
}

static gchar*
keybinding_manager_value_keybinding_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (collect_values[0].v_pointer) {
#line 949 "KeybindingManager.c"
		KeybindingManagerKeybinding * object;
		object = collect_values[0].v_pointer;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 956 "KeybindingManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 960 "KeybindingManager.c"
		}
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		value->data[0].v_pointer = keybinding_manager_keybinding_ref (object);
#line 964 "KeybindingManager.c"
	} else {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		value->data[0].v_pointer = NULL;
#line 968 "KeybindingManager.c"
	}
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return NULL;
#line 972 "KeybindingManager.c"
}

static gchar*
keybinding_manager_value_keybinding_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	KeybindingManagerKeybinding ** object_p;
	object_p = collect_values[0].v_pointer;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (!object_p) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 987 "KeybindingManager.c"
	}
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (!value->data[0].v_pointer) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		*object_p = NULL;
#line 993 "KeybindingManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		*object_p = value->data[0].v_pointer;
#line 997 "KeybindingManager.c"
	} else {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		*object_p = keybinding_manager_keybinding_ref (value->data[0].v_pointer);
#line 1001 "KeybindingManager.c"
	}
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return NULL;
#line 1005 "KeybindingManager.c"
}

static GParamSpec*
keybinding_manager_param_spec_keybinding (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	KeybindingManagerParamSpecKeybinding* spec;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, KEYBINDING_MANAGER_TYPE_KEYBINDING), NULL);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return G_PARAM_SPEC (spec);
#line 1024 "KeybindingManager.c"
}

static gpointer
keybinding_manager_value_get_keybinding (const GValue* value)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KEYBINDING_MANAGER_TYPE_KEYBINDING), NULL);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return value->data[0].v_pointer;
#line 1034 "KeybindingManager.c"
}

static void
keybinding_manager_value_set_keybinding (GValue* value,
                                         gpointer v_object)
{
	KeybindingManagerKeybinding * old;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KEYBINDING_MANAGER_TYPE_KEYBINDING));
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	old = value->data[0].v_pointer;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (v_object) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KEYBINDING_MANAGER_TYPE_KEYBINDING));
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		value->data[0].v_pointer = v_object;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		keybinding_manager_keybinding_ref (value->data[0].v_pointer);
#line 1056 "KeybindingManager.c"
	} else {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		value->data[0].v_pointer = NULL;
#line 1060 "KeybindingManager.c"
	}
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (old) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		keybinding_manager_keybinding_unref (old);
#line 1066 "KeybindingManager.c"
	}
}

static void
keybinding_manager_value_take_keybinding (GValue* value,
                                          gpointer v_object)
{
	KeybindingManagerKeybinding * old;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, KEYBINDING_MANAGER_TYPE_KEYBINDING));
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	old = value->data[0].v_pointer;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (v_object) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, KEYBINDING_MANAGER_TYPE_KEYBINDING));
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		value->data[0].v_pointer = v_object;
#line 1087 "KeybindingManager.c"
	} else {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		value->data[0].v_pointer = NULL;
#line 1091 "KeybindingManager.c"
	}
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (old) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		keybinding_manager_keybinding_unref (old);
#line 1097 "KeybindingManager.c"
	}
}

static void
keybinding_manager_keybinding_class_init (KeybindingManagerKeybindingClass * klass,
                                          gpointer klass_data)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_keybinding_parent_class = g_type_class_peek_parent (klass);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	((KeybindingManagerKeybindingClass *) klass)->finalize = keybinding_manager_keybinding_finalize;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_type_class_adjust_private_offset (klass, &KeybindingManagerKeybinding_private_offset);
#line 1111 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_instance_init (KeybindingManagerKeybinding * self,
                                             gpointer klass)
{
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv = keybinding_manager_keybinding_get_instance_private (self);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->ref_count = 1;
#line 1122 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_finalize (KeybindingManagerKeybinding * obj)
{
	KeybindingManagerKeybinding * self;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBINDING_MANAGER_TYPE_KEYBINDING, KeybindingManagerKeybinding);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_signal_handlers_destroy (self);
#line 46 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_free0 (self->priv->_accelerator);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	(self->priv->_handler_target_destroy_notify == NULL) ? NULL : (self->priv->_handler_target_destroy_notify (self->priv->_handler_target), NULL);
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler = NULL;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler_target = NULL;
#line 49 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->_handler_target_destroy_notify = NULL;
#line 1143 "KeybindingManager.c"
}

static GType
keybinding_manager_keybinding_get_type (void)
{
	static volatile gsize keybinding_manager_keybinding_type_id__volatile = 0;
	if (g_once_init_enter (&keybinding_manager_keybinding_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { keybinding_manager_value_keybinding_init, keybinding_manager_value_keybinding_free_value, keybinding_manager_value_keybinding_copy_value, keybinding_manager_value_keybinding_peek_pointer, "p", keybinding_manager_value_keybinding_collect_value, "p", keybinding_manager_value_keybinding_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (KeybindingManagerKeybindingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keybinding_manager_keybinding_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeybindingManagerKeybinding), 0, (GInstanceInitFunc) keybinding_manager_keybinding_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType keybinding_manager_keybinding_type_id;
		keybinding_manager_keybinding_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KeybindingManagerKeybinding", &g_define_type_info, &g_define_type_fundamental_info, 0);
		KeybindingManagerKeybinding_private_offset = g_type_add_instance_private (keybinding_manager_keybinding_type_id, sizeof (KeybindingManagerKeybindingPrivate));
		g_once_init_leave (&keybinding_manager_keybinding_type_id__volatile, keybinding_manager_keybinding_type_id);
	}
	return keybinding_manager_keybinding_type_id__volatile;
}

static gpointer
keybinding_manager_keybinding_ref (gpointer instance)
{
	KeybindingManagerKeybinding * self;
	self = instance;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	return instance;
#line 1171 "KeybindingManager.c"
}

static void
keybinding_manager_keybinding_unref (gpointer instance)
{
	KeybindingManagerKeybinding * self;
	self = instance;
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		KEYBINDING_MANAGER_KEYBINDING_GET_CLASS (self)->finalize (self);
#line 36 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1185 "KeybindingManager.c"
	}
}

static void
keybinding_manager_class_init (KeybindingManagerClass * klass,
                               gpointer klass_data)
{
	guint* _tmp0_;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	g_type_class_adjust_private_offset (klass, &KeybindingManager_private_offset);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	G_OBJECT_CLASS (klass)->finalize = keybinding_manager_finalize;
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = g_new0 (guint, 8);
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[0] = (guint) 0;
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[1] = (guint) GDK_MOD2_MASK;
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[2] = (guint) GDK_LOCK_MASK;
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[3] = (guint) GDK_MOD5_MASK;
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[4] = (guint) (GDK_MOD2_MASK | GDK_LOCK_MASK);
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[5] = (guint) (GDK_MOD2_MASK | GDK_MOD5_MASK);
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[6] = (guint) (GDK_LOCK_MASK | GDK_MOD5_MASK);
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_[7] = (guint) ((GDK_MOD2_MASK | GDK_LOCK_MASK) | GDK_MOD5_MASK);
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_lock_modifiers = _tmp0_;
#line 25 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	keybinding_manager_lock_modifiers_length1 = 8;
#line 1222 "KeybindingManager.c"
}

static void
keybinding_manager_instance_init (KeybindingManager * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv = keybinding_manager_get_instance_private (self);
#line 24 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_tmp0_ = gee_array_list_new (KEYBINDING_MANAGER_TYPE_KEYBINDING, (GBoxedCopyFunc) keybinding_manager_keybinding_ref, (GDestroyNotify) keybinding_manager_keybinding_unref, NULL, NULL, NULL);
#line 24 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self->priv->bindings = (GeeList*) _tmp0_;
#line 1236 "KeybindingManager.c"
}

static void
keybinding_manager_finalize (GObject * obj)
{
	KeybindingManager * self;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KEYBINDING_MANAGER, KeybindingManager);
#line 24 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	_g_object_unref0 (self->priv->bindings);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/KeybindingManager.vala"
	G_OBJECT_CLASS (keybinding_manager_parent_class)->finalize (obj);
#line 1249 "KeybindingManager.c"
}

GType
keybinding_manager_get_type (void)
{
	static volatile gsize keybinding_manager_type_id__volatile = 0;
	if (g_once_init_enter (&keybinding_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KeybindingManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keybinding_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeybindingManager), 0, (GInstanceInitFunc) keybinding_manager_instance_init, NULL };
		GType keybinding_manager_type_id;
		keybinding_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "KeybindingManager", &g_define_type_info, 0);
		KeybindingManager_private_offset = g_type_add_instance_private (keybinding_manager_type_id, sizeof (KeybindingManagerPrivate));
		g_once_init_leave (&keybinding_manager_type_id__volatile, keybinding_manager_type_id);
	}
	return keybinding_manager_type_id__volatile;
}

