/* AlertView.c generated by valac 0.46.6, the Vala compiler
 * generated from AlertView.vala, do not modify */

/*
 *  Copyright (C) 2012-2017 Granite Developers (https://launchpad.net/granite)
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 *
 *  Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#define CLIPPED_WIDGETS_TYPE_ALERT_VIEW (clipped_widgets_alert_view_get_type ())
#define CLIPPED_WIDGETS_ALERT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView))
#define CLIPPED_WIDGETS_ALERT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertViewClass))
#define CLIPPED_WIDGETS_IS_ALERT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLIPPED_WIDGETS_TYPE_ALERT_VIEW))
#define CLIPPED_WIDGETS_IS_ALERT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLIPPED_WIDGETS_TYPE_ALERT_VIEW))
#define CLIPPED_WIDGETS_ALERT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertViewClass))

typedef struct _ClippedWidgetsAlertView ClippedWidgetsAlertView;
typedef struct _ClippedWidgetsAlertViewClass ClippedWidgetsAlertViewClass;
typedef struct _ClippedWidgetsAlertViewPrivate ClippedWidgetsAlertViewPrivate;
enum  {
	CLIPPED_WIDGETS_ALERT_VIEW_0_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY,
	CLIPPED_WIDGETS_ALERT_VIEW_NUM_PROPERTIES
};
static GParamSpec* clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ClippedWidgetsAlertView {
	GtkGrid parent_instance;
	ClippedWidgetsAlertViewPrivate * priv;
};

struct _ClippedWidgetsAlertViewClass {
	GtkGridClass parent_class;
};

struct _ClippedWidgetsAlertViewPrivate {
	GtkLabel* title_label;
	GtkLabel* description_label;
	GtkImage* image;
};

static gint ClippedWidgetsAlertView_private_offset;
static gpointer clipped_widgets_alert_view_parent_class = NULL;

GType clipped_widgets_alert_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClippedWidgetsAlertView, g_object_unref)
ClippedWidgetsAlertView* clipped_widgets_alert_view_new (const gchar* title,
                                                         const gchar* description,
                                                         const gchar* icon_name);
ClippedWidgetsAlertView* clipped_widgets_alert_view_construct (GType object_type,
                                                               const gchar* title,
                                                               const gchar* description,
                                                               const gchar* icon_name);
const gchar* clipped_widgets_alert_view_get_title (ClippedWidgetsAlertView* self);
void clipped_widgets_alert_view_set_title (ClippedWidgetsAlertView* self,
                                           const gchar* value);
const gchar* clipped_widgets_alert_view_get_description (ClippedWidgetsAlertView* self);
void clipped_widgets_alert_view_set_description (ClippedWidgetsAlertView* self,
                                                 const gchar* value);
gchar* clipped_widgets_alert_view_get_icon_name (ClippedWidgetsAlertView* self);
void clipped_widgets_alert_view_set_icon_name (ClippedWidgetsAlertView* self,
                                               const gchar* value);
static GObject * clipped_widgets_alert_view_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void clipped_widgets_alert_view_finalize (GObject * obj);
static void _vala_clipped_widgets_alert_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_clipped_widgets_alert_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
clipped_widgets_alert_view_get_instance_private (ClippedWidgetsAlertView* self)
{
	return G_STRUCT_MEMBER_P (self, ClippedWidgetsAlertView_private_offset);
}

/**
     * Makes new AlertView
     *
     * @param title the first line of text
     * @param description the second line of text
     * @param icon_name the icon to be shown
     */
ClippedWidgetsAlertView*
clipped_widgets_alert_view_construct (GType object_type,
                                      const gchar* title,
                                      const gchar* description,
                                      const gchar* icon_name)
{
	ClippedWidgetsAlertView * self = NULL;
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 72 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self = (ClippedWidgetsAlertView*) g_object_new (object_type, "title", title, "description", description, "icon-name", icon_name, NULL);
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	return self;
#line 134 "AlertView.c"
}

ClippedWidgetsAlertView*
clipped_widgets_alert_view_new (const gchar* title,
                                const gchar* description,
                                const gchar* icon_name)
{
#line 71 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	return clipped_widgets_alert_view_construct (CLIPPED_WIDGETS_TYPE_ALERT_VIEW, title, description, icon_name);
#line 144 "AlertView.c"
}

const gchar*
clipped_widgets_alert_view_get_title (ClippedWidgetsAlertView* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 27 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = self->priv->title_label;
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp2_ = _tmp1_;
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	result = _tmp2_;
#line 28 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	return result;
#line 166 "AlertView.c"
}

void
clipped_widgets_alert_view_set_title (ClippedWidgetsAlertView* self,
                                      const gchar* value)
{
	GtkLabel* _tmp0_;
#line 30 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_if_fail (self != NULL);
#line 31 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = self->priv->title_label;
#line 31 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_label_set_label (_tmp0_, value);
#line 30 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_notify_by_pspec ((GObject *) self, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY]);
#line 182 "AlertView.c"
}

const gchar*
clipped_widgets_alert_view_get_description (ClippedWidgetsAlertView* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 40 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = self->priv->description_label;
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp2_ = _tmp1_;
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	result = _tmp2_;
#line 41 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	return result;
#line 204 "AlertView.c"
}

void
clipped_widgets_alert_view_set_description (ClippedWidgetsAlertView* self,
                                            const gchar* value)
{
	GtkLabel* _tmp0_;
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_if_fail (self != NULL);
#line 44 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = self->priv->description_label;
#line 44 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_label_set_label (_tmp0_, value);
#line 43 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_notify_by_pspec ((GObject *) self, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY]);
#line 220 "AlertView.c"
}

gchar*
clipped_widgets_alert_view_get_icon_name (ClippedWidgetsAlertView* self)
{
	gchar* result;
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 52 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = self->priv->image;
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_get (_tmp0_, "icon-name", &_tmp1_, NULL);
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp2_ = _tmp1_;
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	result = _tmp2_;
#line 53 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	return result;
#line 242 "AlertView.c"
}

void
clipped_widgets_alert_view_set_icon_name (ClippedWidgetsAlertView* self,
                                          const gchar* value)
{
	GtkImage* _tmp0_;
#line 55 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_return_if_fail (self != NULL);
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = self->priv->image;
#line 56 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_image_set_from_icon_name (_tmp0_, value, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 55 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_notify_by_pspec ((GObject *) self, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY]);
#line 258 "AlertView.c"
}

static GObject *
clipped_widgets_alert_view_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ClippedWidgetsAlertView * self;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkImage* _tmp15_;
	GtkEventBox* image_box = NULL;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
	GtkImage* _tmp20_;
	GtkEventBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	parent_class = G_OBJECT_CLASS (clipped_widgets_alert_view_parent_class);
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 76 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_VIEW);
#line 78 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 78 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_ref_sink (_tmp1_);
#line 78 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (self->priv->title_label);
#line 78 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self->priv->title_label = _tmp1_;
#line 79 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp2_ = self->priv->title_label;
#line 79 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp3_ = self->priv->title_label;
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 80 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_style_context_add_class (_tmp4_, "h2");
#line 81 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp5_ = self->priv->title_label;
#line 81 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_label_set_max_width_chars (_tmp5_, 45);
#line 82 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp6_ = self->priv->title_label;
#line 82 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_set (_tmp6_, "wrap", TRUE, NULL);
#line 83 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp7_ = self->priv->title_label;
#line 83 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_set (_tmp7_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 84 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp8_ = self->priv->title_label;
#line 84 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_label_set_xalign (_tmp8_, (gfloat) 0);
#line 86 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 86 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_ref_sink (_tmp9_);
#line 86 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (self->priv->description_label);
#line 86 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self->priv->description_label = _tmp9_;
#line 87 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp10_ = self->priv->description_label;
#line 87 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp10_, TRUE);
#line 88 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp11_ = self->priv->description_label;
#line 88 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_set (_tmp11_, "wrap", TRUE, NULL);
#line 89 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp12_ = self->priv->description_label;
#line 89 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_label_set_use_markup (_tmp12_, TRUE);
#line 90 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp13_ = self->priv->description_label;
#line 90 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
#line 91 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp14_ = self->priv->description_label;
#line 91 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_START);
#line 93 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp15_ = (GtkImage*) gtk_image_new ();
#line 93 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_ref_sink (_tmp15_);
#line 93 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (self->priv->image);
#line 93 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self->priv->image = _tmp15_;
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp16_ = (GtkEventBox*) gtk_event_box_new ();
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_ref_sink (_tmp16_);
#line 94 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	image_box = _tmp16_;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp17_ = image_box;
#line 95 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp17_, 6);
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp18_ = image_box;
#line 96 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp19_ = image_box;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp20_ = self->priv->image;
#line 97 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 99 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 100 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
#line 101 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 102 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 103 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 104 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_set ((GtkWidget*) self, "margin", 24, NULL);
#line 106 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp21_ = image_box;
#line 106 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp21_, 1, 1, 1, 2);
#line 107 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp22_ = self->priv->title_label;
#line 107 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp22_, 2, 1, 1, 1);
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_tmp23_ = self->priv->description_label;
#line 108 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp23_, 2, 2, 1, 1);
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (image_box);
#line 75 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	return obj;
#line 422 "AlertView.c"
}

static void
clipped_widgets_alert_view_class_init (ClippedWidgetsAlertViewClass * klass,
                                       gpointer klass_data)
{
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	clipped_widgets_alert_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_type_class_adjust_private_offset (klass, &ClippedWidgetsAlertView_private_offset);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_clipped_widgets_alert_view_get_property;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_clipped_widgets_alert_view_set_property;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	G_OBJECT_CLASS (klass)->constructor = clipped_widgets_alert_view_constructor;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	G_OBJECT_CLASS (klass)->finalize = clipped_widgets_alert_view_finalize;
#line 441 "AlertView.c"
	/**
	     * The first line of text, should be short and not contain markup.
	     */
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 447 "AlertView.c"
	/**
	     * The second line of text, explaining why this alert is shown.
	     * You may need to escape it with #escape_text or #printf_escaped
	     */
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 454 "AlertView.c"
	/**
	     * The icon name
	     */
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY, clipped_widgets_alert_view_properties[CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 460 "AlertView.c"
}

static void
clipped_widgets_alert_view_instance_init (ClippedWidgetsAlertView * self,
                                          gpointer klass)
{
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self->priv = clipped_widgets_alert_view_get_instance_private (self);
#line 469 "AlertView.c"
}

static void
clipped_widgets_alert_view_finalize (GObject * obj)
{
	ClippedWidgetsAlertView * self;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
#line 60 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (self->priv->title_label);
#line 61 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (self->priv->description_label);
#line 62 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	_g_object_unref0 (self->priv->image);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	G_OBJECT_CLASS (clipped_widgets_alert_view_parent_class)->finalize (obj);
#line 486 "AlertView.c"
}

GType
clipped_widgets_alert_view_get_type (void)
{
	static volatile gsize clipped_widgets_alert_view_type_id__volatile = 0;
	if (g_once_init_enter (&clipped_widgets_alert_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClippedWidgetsAlertViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clipped_widgets_alert_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClippedWidgetsAlertView), 0, (GInstanceInitFunc) clipped_widgets_alert_view_instance_init, NULL };
		GType clipped_widgets_alert_view_type_id;
		clipped_widgets_alert_view_type_id = g_type_register_static (gtk_grid_get_type (), "ClippedWidgetsAlertView", &g_define_type_info, 0);
		ClippedWidgetsAlertView_private_offset = g_type_add_instance_private (clipped_widgets_alert_view_type_id, sizeof (ClippedWidgetsAlertViewPrivate));
		g_once_init_leave (&clipped_widgets_alert_view_type_id__volatile, clipped_widgets_alert_view_type_id);
	}
	return clipped_widgets_alert_view_type_id__volatile;
}

static void
_vala_clipped_widgets_alert_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	ClippedWidgetsAlertView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	switch (property_id) {
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		case CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		g_value_set_string (value, clipped_widgets_alert_view_get_title (self));
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		case CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		g_value_set_string (value, clipped_widgets_alert_view_get_description (self));
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		case CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		g_value_take_string (value, clipped_widgets_alert_view_get_icon_name (self));
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 531 "AlertView.c"
		default:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 537 "AlertView.c"
	}
}

static void
_vala_clipped_widgets_alert_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	ClippedWidgetsAlertView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLIPPED_WIDGETS_TYPE_ALERT_VIEW, ClippedWidgetsAlertView);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
	switch (property_id) {
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		case CLIPPED_WIDGETS_ALERT_VIEW_TITLE_PROPERTY:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		clipped_widgets_alert_view_set_title (self, g_value_get_string (value));
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		case CLIPPED_WIDGETS_ALERT_VIEW_DESCRIPTION_PROPERTY:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		clipped_widgets_alert_view_set_description (self, g_value_get_string (value));
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		case CLIPPED_WIDGETS_ALERT_VIEW_ICON_NAME_PROPERTY:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		clipped_widgets_alert_view_set_icon_name (self, g_value_get_string (value));
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 569 "AlertView.c"
		default:
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/home/abuild/rpmbuild/BUILD/clipped-1.0.2/src/Widgets/AlertView.vala"
		break;
#line 575 "AlertView.c"
	}
}

